<template>
  <section class="flex items-center gap-2 text-2xl text-gray-400 font-light uppercase mb-6">
    <v-icon icon="mdi-home-analytics" />
    За год
  </section>

  <YearlyStatsSkeleton v-if="isLoading" />

  <section
    v-if="!isLoading"
    class="block md:flex items-center gap-4 mb-4"
  >
    <PropertyFilter
      v-model="selectedProperty"
      class="w-full md:max-w-[316px]"
      clearable
    />

    <v-select
      v-model="selectedYear"
      :items="availableYears"
      class="w-full md:max-w-[316px] mt-4 md:mt-0"
      label="Год"
      hide-details
    />
  </section>

  <section
    v-if="!isLoading"
    class="grid grid-cols-12 gap-4 md:gap-6"
  >
    <section class="col-span-12 xl:col-span-6 grid grid-cols-12 gap-4 md:gap-6">
      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-cash-multiple"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <ProfitDisplay
              mode="display"
              :value="stats.totalProfit"
              disable-label
            />

            <section class="text-gray-400 text-sm">
              Суммарная прибыль
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-circle-multiple"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <ProfitDisplay
              mode="display"
              :value="stats.recordProfit"
              disable-label
            />

            <section class="text-gray-400 text-sm">
              Рекордная прибыль
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-account-multiple"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.totalGuests }} {{ getGuestsLabel(stats.totalGuests) }}
            </section>

            <section class="text-gray-400 text-sm">
              Суммарное кол-во
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-account-star"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.recordGuests }} {{ getGuestsLabel(stats.recordGuests) }}
            </section>

            <section class="text-gray-400 text-sm">
              Рекордное кол-во
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-star"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section class="truncate">
            <section
              v-tooltip:top-start="{ text: stats.favoriteProperty.name, openOnClick: true }"
              class="text-xl truncate"
            >
              {{ stats.favoriteProperty.name }}
            </section>

            <section class="text-gray-400 text-sm">
              Самый популярный
            </section>
          </section>
        </section>
      </Container>

      <Container class="h-full col-span-12 md:col-span-6 !p-4 border-l-teal-600 border-l-4">
        <section class="h-full flex items-center gap-4">
          <v-btn
            icon="mdi-calendar-multiselect-outline"
            variant="tonal"
            class="text-teal-600"
            readonly
          />

          <section>
            <section class="text-2xl">
              {{ stats.bookingsCount }} {{ getTimesLabel(stats.bookingsCount) }}
            </section>

            <section class="text-gray-400 text-sm">
              Бронировали
            </section>
          </section>
        </section>
      </Container>
    </section>

    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-calendar-lock-outline">
        Бронирования
      </SectionHeader>

      <Chart
        :options="{
          type: 'line',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Бронирования',
                backgroundColor: 'rgba(14, 144, 135, 0.2)',
                borderColor: 'rgba(14, 144, 135, 1)',
                borderWidth: 2,
                data: stats.bookingsGraphData,
                fill: 'start',
              },
            ],
          },
          options: {
            responsive: true,
            scales: { y: { beginAtZero: true } },
            elements: { line: { tension: 0.4 } },
            plugins: {
              filler: { propagate: false },
            },
            interaction: {
              intersect: false,
            }
          },
        }"
      />
    </Container>

    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-cash-fast">
        Прибыль
      </SectionHeader>

      <Chart
        :options="{
          type: 'line',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Прибыль',
                backgroundColor: 'rgba(14, 144, 135, 0.2)',
                borderColor: 'rgba(14, 144, 135, 1)',
                borderWidth: 2,
                data: stats.profitGraphData,
                fill: 'start',
              },
            ],
          },
          options: {
            responsive: true,
            scales: { y: { beginAtZero: true } },
            elements: { line: { tension: 0.4 } },
            plugins: {
              filler: { propagate: false },
            },
            interaction: {
              intersect: false,
            }
          },
        }"
      />
    </Container>

    <Container class="h-full col-span-12 xl:col-span-6">
      <SectionHeader icon="mdi-briefcase-account-outline">
        Гости
      </SectionHeader>

      <Chart
        :options="{
          type: 'line',
          data: {
            labels: labels,
            datasets: [
              {
                label: 'Гости',
                backgroundColor: 'rgba(14, 144, 135, 0.2)',
                borderColor: 'rgba(14, 144, 135, 1)',
                borderWidth: 2,
                data: stats.guestsGraphData,
                fill: 'start',
              },
            ],
          },
          options: {
            responsive: true,
            scales: { y: { beginAtZero: true } },
            elements: { line: { tension: 0.4 } },
            plugins: {
              filler: { propagate: false },
            },
            interaction: {
              intersect: false,
            }
          },
        }"
      />
    </Container>
  </section>

  <v-overlay
    :model-value="isOverlayLoading"
    class="items-center justify-center"
    scrim="white"
    persistent
  >
    <v-progress-circular
      color="var(--tw-color-teal-600)"
      size="64"
      indeterminate
    />
  </v-overlay>
</template>

<script setup lang="ts">
import { onMounted, reactive, ref, watch } from 'vue';

import { HttpClient } from '@/http';
import { useDateTime } from '@/composables';
import { getGuestsLabel, getTimesLabel } from '@/utils';

import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import Chart from '@/components/content/Chart.vue';

import PropertyFilter from '@/pages/bookings/filters/PropertyFilter.vue';
import YearlyStatsSkeleton from '@/components/skeletons/YearlyStatsSkeleton.vue';

const emit = defineEmits(['loading:start', 'loading:end']);
const dt = useDateTime();

const isLoading = ref(false);
const isOverlayLoading = ref(false);

const selectedProperty = ref<IProperty | null>(null);
const selectedYear = ref(new Date().getFullYear());
const availableYears = ref([new Date().getFullYear()]);

const getLabels = () => {
  const year = new Date().getFullYear();

  return Array.from({ length: 12 }, (_, index) => {
    return dt.origin.local(year, index + 1, { locale: 'ru' }).toFormat('MMM');
  });
};

const labels = reactive(getLabels());
const stats = reactive({
  totalProfit: 0,
  recordProfit: 0,
  totalGuests: 0,
  recordGuests: 0,
  bookingsCount: 0,
  favoriteProperty: {
    name: 'Нет данных'
  },
  profitGraphData: [],
  guestsGraphData: [],
  bookingsGraphData: [],
});

const startLoading = (type: 'skeleton' | 'overlay') => {
  if (isLoading.value) return;

  if (type === 'skeleton') isLoading.value = true;
  if (type === 'overlay') isOverlayLoading.value = true;

  emit('loading:start');
};

const stopLoading = (type: 'skeleton' | 'overlay') => {
  if (type === 'skeleton') isLoading.value = false;
  if (type === 'overlay') isOverlayLoading.value = false;

  emit('loading:end');
};

const loadBoundaries = async () => {
  const { data: { values, error } } = (
    await HttpClient.get('/v1/dashboard/boundaries')
  );

  if (error) {
    return;
  }

  const startDate = dt.wrap(values.start);
  const endDate = dt.wrap(values.end);

  const yearsRange: number[] = [];

  for (let year = startDate.year; year <= endDate.year; year++) {
    yearsRange.push(year);
  }

  availableYears.value = yearsRange;

  if (yearsRange.length && !yearsRange.includes(new Date().getFullYear())) {
    selectedYear.value = yearsRange[0];
  }
};

const getRequestParams = () => {
  const year = selectedYear.value;

  const searchStart = dt.origin
    .local(year, 1, 1)
    .startOf('year')
    .set({ hour: 13, minute: 59, second: 59, millisecond: 999 });

  const searchEnd = dt.origin
    .local(year, 1, 1)
    .endOf('year');

  const propertyId = selectedProperty.value?.id;

  return {
    start: encodeURIComponent(searchStart.toISO()!),
    end: encodeURIComponent(searchEnd.toISO()!),
    ...(propertyId && { propertyId }),
  };
};

const loadYearlyStats = async () => {
  const { data: { values, error } } = (
    await HttpClient.get('/v1/dashboard/stats/yearly', {
      params: getRequestParams(),
    })
  );

  if (error) return;

  stats.totalProfit = values.totalProfit;
  stats.recordProfit = values.recordProfit;
  stats.totalGuests = values.totalGuests;
  stats.recordGuests = values.recordGuests;
  stats.bookingsCount = values.bookingsCount;
  stats.favoriteProperty = values.favoriteProperty;
  stats.profitGraphData = values.profitGraphData;
  stats.guestsGraphData = values.guestsGraphData;
  stats.bookingsGraphData = values.bookingsGraphData;
};

watch(selectedYear, async () => {
  startLoading('overlay');
  await loadYearlyStats();
  stopLoading('overlay');
});

watch(selectedProperty, async () => {
  startLoading('overlay');
  await loadYearlyStats();
  stopLoading('overlay');
});

onMounted(async () => {
  startLoading('skeleton');

  await Promise.all([
    loadBoundaries(),
    loadYearlyStats(),
  ]);

  stopLoading('skeleton');
});
</script>